﻿'
' Created by SharpDevelop.
' User: Martinevski
' Date: 27.02.2014
' Time: 16:24
'

Imports System.Net.Sockets
Imports System.IO
Imports WFF_GenericHID_Communication_Library


Public Partial Class MainForm
	Public Sub New()
		' The Me.InitializeComponent call is required for Windows Forms designer support.
		Me.InitializeComponent()
        '
		' TODO : Add constructor code after InitializeComponents
		'
		rdBut_LAN.Checked = True
		
    End Sub
    Public ConnectionToCardUSB As USBCommunicationClass = Nothing
    Private _ConnectionUSB As String
    Public Property ConnectionUSB() As String
        Get
            Return _ConnectionUSB
        End Get
        Set(ByVal value As String)
            _ConnectionUSB = value
        End Set
    End Property
    Private _ConnectionState As String
    Public Property ConnectionState() As String
        Get
            Return _ConnectionState
        End Get
        Set(ByVal value As String)
            _ConnectionState = value
        End Set
    End Property
    
    
''' <summary>
''' Exit 
''' </summary>
''' <param name="sender"></param>
''' <param name="e"></param>

    Sub Btn_exitClick(ByVal sender As Object, ByVal e As EventArgs)
        End
    End Sub
    
'''' <summary>
'''  Connect to Relay Card via USB, OR Test LAN Connection
''' </summary>
''' <param name="sender"></param>
''' <param name="e"></param>
''' 
    Sub Btn_conn_lanClick(ByVal sender As Object, ByVal e As EventArgs)
    	'USB Definitions
    	Dim USBVID As Integer = &H3EB
        Dim USBPId As Integer = &H2403
        ConnectionToCardUSB = New USBCommunicationClass(USBVID, USBPId)
        AddHandler ConnectionToCardUSB.usbEvent, New USBCommunicationClass.usbEventsHandler(AddressOf usbEvent_receiver)
        
		'LAN definitions
        Dim stream As NetworkStream
        Dim tcpClient As New TcpClient
        Dim IP As String = txtBox_IP.Text
        Dim Port As Integer = CInt(txtBox_Port.Text)
        Dim DevSerial As Byte() = New Byte() {0, 0, 0, 0, 0, 0, 0, 0, 0, 0}

        'TQIO Data Frame		|------------HEADER----------|-CMD-|-CONST-|------DATA------|
        Dim ioData As Byte() = {&H54, &H51, &H49, &H4F, &H0, &H0, &H0, &H0, &H0, &H0}
        
        If rdBut_LAN.Checked Then
	        tcpClient.Connect(IP, Port)
	        If tcpClient.Connected Then
	            stream = tcpClient.GetStream
	            stream.Write(ioData, 0, ioData.Length)
	            stream.Read(DevSerial, 0, DevSerial.Length)
	            txtBox_DevSer_Relay.Text = BitConverter.ToString(DevSerial)
	            stream.Close()
	        End If
        End If
        
        If rdBut_USB.Checked Then
        	ConnectionToCardUSB.findTargetDevice()
        	If ConnectionToCardUSB.isDeviceAttached Then
           	 txtBox_DevSer_Relay.Text = "USB Connected"
       		 Else
            	txtBox_DevSer_Relay.Text = "No Device found"
        	End If 	
        End If
    End Sub
    
'''' <summary>
'''  Set Relay Outputs via LAN or via USB
''' </summary>
''' <param name="sender"></param>
''' <param name="e"></param>
''' 
    Sub Btn_set_outputClick(ByVal sender As Object, ByVal e As EventArgs)
    	'LAN definitions
    	Dim cnt As Integer = 0
        Dim stream As NetworkStream
        Dim tcpClient As New TcpClient
        Dim IP As String = txtBox_IP.Text
        Dim Port As Integer = CInt(txtBox_Port.Text)

        'TQIO Data Frame		|------------HEADER----------|-CMD-|-CONST-|------DATA------|
        Dim ioData As Byte() = {&H54, &H51, &H49, &H4F, &H0, &H10, &H0, &H0, &H0, &H0}
        
        'Buffer for answer from Device
		Dim answer As Byte() = New [Byte](27) {}
		
		'Read Check Box Values in ioData Byte 0
		cnt = 0
		For Each chBox In {chBox_REL_1,chBox_REL_2,chBox_REL_3,chBox_REL_4,chBox_REL_5,chBox_REL_6,chBox_REL_7,chBox_REL_8}				
			If chBox.Checked Then
				ioData(7) = CByte(ioData(7) Or (1<<cnt)) 
			Else
				ioData(7) = CByte(ioData(7) And Not (1<<cnt))
			End If
			cnt += 1
		Next
		
		'Read Check Box Values in ioData Byte 1
		cnt = 0
		For Each chBox In {chBox_REL_9,chBox_REL_10,chBox_REL_11,chBox_REL_12,chBox_REL_13,chBox_REL_14,chBox_REL_15,chBox_REL_16}				
			If chBox.Checked Then
				ioData(8) = CByte(ioData(8) Or (1<<cnt)) 
			Else
				ioData(8) = CByte(ioData(8) And Not (1<<cnt))
			End If
			cnt += 1
		Next
		
		'Read Check Box Values in ioData Byte 2
		cnt = 0
		For Each chBox In {chBox_REL_17,chBox_REL_18,chBox_REL_19,chBox_REL_20,chBox_REL_21,chBox_REL_22,chBox_REL_23,chBox_REL_24}				
			If chBox.Checked Then
				ioData(9) = CByte(ioData(9) Or (1<<cnt)) 
			Else
				ioData(9) = CByte(ioData(9) And Not (1<<cnt))
			End If
			cnt += 1
		Next
		
		'Communication selection
        If rdBut_LAN.Checked Then
        	tcpClient.Connect(IP, Port)
       		If tcpClient.Connected Then
            	stream = tcpClient.GetStream
            	stream.Write(ioData, 0, ioData.Length)
            	stream.Close()
        	End If	
        End If
        
        If rdBut_USB.Checked Then
        	Array.Resize(ioData, 64)
        	If ConnectionToCardUSB IsNot Nothing Then
        	    If ConnectionToCardUSB.writeSingleReportToDevice(ioData) = False Then
        			txtBox_DevSer_Relay.Text = "USB Comm Failed"
        		Else
        			Array.Resize(answer, 64)
        			'read the answer
        			ConnectionToCardUSB.readSingleReportFromDevice(answer)
        			'check if answer is correct -> see manual page 18
        			If answer(0)=&H10 And answer(1)=0 And answer(2)=&H5A
        				txtBox_DevSer_Relay.Text = "USB Comm Passed" 
        			Else
        				txtBox_DevSer_Relay.Text = "No Acknowledge" 
        			End If
        		End If	
        	Else
        		txtBox_DevSer_Relay.Text = "Connect first!"
        	End If	
        End If
    End Sub
    
''' <summary>
'''  Set Connectivity State
''' </summary>
''' <param name="o"></param>
''' <param name="e"></param>
''' 
    Private Sub usbEvent_receiver(ByVal o As Object, ByVal e As EventArgs)
        If (ConnectionToCardUSB.isDeviceAttached) AndAlso (ConnectionUSB = "Visible") Then
            ConnectionState = "Connected"
        ElseIf Not (ConnectionToCardUSB.isDeviceAttached) AndAlso (ConnectionUSB = "Visible") Then
            ConnectionState = "Disconnected"
        End If
    End Sub
    
''' <summary>
''' Connect DIgital Input Card over USB
''' </summary>
''' <param name="sender"></param>
''' <param name="e"></param>
''' 
	Sub Btn_conn_usbClick(sender As Object, e As EventArgs)
		
		Dim USBVID As Integer = &H3EB
        Dim USBPId As Integer = &H2402

        ConnectionToCardUSB = New USBCommunicationClass(USBVID, USBPId)
        AddHandler ConnectionToCardUSB.usbEvent, New USBCommunicationClass.usbEventsHandler(AddressOf usbEvent_receiver)
        ConnectionToCardUSB.findTargetDevice()

        If ConnectionToCardUSB.isDeviceAttached Then
            txtBox_DevSer_DIC.Text = "USB Connected"
        Else
            txtBox_DevSer_DIC.Text = "No Device found"
        End If
	End Sub
		
''' <summary>
''' Read Ditial IO 
''' </summary>
''' <param name="sender"></param>
''' <param name="e"></param>
''' 
	Sub Btn_get_inputClick(sender As Object, e As EventArgs)
		
		Dim cnt As Integer = 0
		
		'Buffer for answer from Device
		Dim answer As Byte() = New [Byte](27) {}		
		'TQIO Data Frame		|------------HEADER----------|-CMD-|-CONST-|
        Dim ioData As Byte() = {&H54, &H51, &H49, &H4F, &H0,  &H20,   &H0}

        Array.Resize(ioData, 8)
        
        'Write CMD to card
        If ConnectionToCardUSB IsNot Nothing Then
       		If ConnectionToCardUSB.writeSingleReportToDevice(ioData) = False Then
        		txtBox_DevSer_DIC.Text = "USB Failed"
        	Else
        		Array.Resize(answer, 8)
        		'receive answer 
        		ConnectionToCardUSB.readSingleReportFromDevice(answer)
        		txtBox_DevSer_DIC.Text = "USB Passed"      			
        	End If
        Else
        	txtBox_DevSer_DIC.Text = "Connect USB first!"
        End If
        
        'set check boxes with data
        For Each chBox_DIC In {chBox_DIN_1,chBox_DIN_2,chBox_DIN_3,chBox_DIN_4,chBox_DIN_5,chBox_DIN_6,chBox_DIN_7,chBox_DIN_8}				
        	If (answer(2) And (1<<cnt)) Then 
        		chBox_DIC.BackColor = Color.LawnGreen
        	Else
        		chBox_DIC.BackColor = Color.Transparent
        	End If
        	cnt += 1
        Next
        
        
	End Sub
	
End Class

''' <summary>
''' USB Comm Class 
''' </summary>
Public Class USBCommunicationClass
    Inherits WFF_GenericHID_Communication_Library.WFF_GenericHID_Communication_Library
    Public Sub New(ByVal vid As Integer, ByVal pid As Integer)
        MyBase.New(vid, pid)
    End Sub
End Class